#include "stdio.h"
#include "conio.h"
#include "iopl32.h"
#include "os2.h"
#include "tp_cmos.h"
#include "pmtposd.h"

unsigned read_cmos(unsigned port)
{
   _outp(0x70,port);
   return ( _inp(0x71) );
}
int main(int argc,char **argv)
{
   THINKPAD_CMOS ptpc;

loop:
   enterIOPL32();
   ptpc.bKeyHome_Toggle        = ( read_cmos(ID_BYTE_INETKEY) & 0x01);
   ptpc.bKeySearch_Toggle      = ( read_cmos(ID_BYTE_INETKEY) & 0x02) >> 1;
   ptpc.bKeyMail_Toggle        = ( read_cmos(ID_BYTE_INETKEY) & 0x04) >> 2;
   ptpc.bKeyThinkpad_Toggle    = ( read_cmos(ID_BYTE_POWER_MISC) & 0x08) >> 3;
   ptpc.bKeyZoom_Toggle        = ( ~read_cmos(ID_BYTE_POWER_MISC)  & 0x20) >> 5;
   ptpc.bKeyDisplay_Toggle     = ( read_cmos(ID_BYTE_POWER_MISC) & 0x40) >> 6;
   ptpc.bKeyThinklight_Toggle  = ( read_cmos(ID_BYTE_THINKLIGHT) & 0x10) >> 4;
   ptpc.bHibernate_Toggle      = ( read_cmos(ID_BYTE_THINKLIGHT) & 0x01);
   ptpc.iSelectedDisplay       = ( read_cmos(ID_BYTE_DISPLAYSTATE) & 0x03);
   ptpc.bKeyExpand_Toggle      = ( read_cmos(ID_BYTE_DISPLAYSTATE) & 0x10) >> 4;
   ptpc.iBrightnessLevel       = ( read_cmos(ID_BYTE_BRIGHTNESS) & 0x07);
   ptpc.bKeyBrightness_Toggle  = ( read_cmos(ID_BYTE_BRIGHTNESS) & 0x20) >> 5;
   ptpc.iVolumeLevel           = ( read_cmos(ID_BYTE_VOLUME) & 0x0f);
   ptpc.bKeyVolume_Toggle      = ( read_cmos(ID_BYTE_VOLUME) & 0x80) >> 7;
   ptpc.bKeyMute_Toggle        = ( read_cmos(ID_BYTE_VOLUME) & 0x40) >> 6;
   leaveIOPL32();
   printf("Thinkpad vol togle =%d\n\r",ptpc.bKeyVolume_Toggle);
   DosSleep(100);
   goto loop;
   return 0;
}
